Name:           python-editdistance
Version:        0.8.1
Release:        %autorelease
Summary:        Fast implementation of the edit distance (Levenshtein distance)

# SPDX
License:        MIT
URL:            https://github.com/roy-ht/editdistance
# The PyPI sdist lacks tests, so we use the GitHub archive.
Source:         %{url}/archive/v%{version}/editdistance-%{version}.tar.gz

BuildRequires:  python3-devel
BuildRequires:  gcc-c++

BuildRequires:  %{py3_dist pytest}

%global _description %{expand:
Fast implementation of the edit distance (Levenshtein distance).

This library simply implements Levenshtein distance with C++ and Cython.

The algorithm used in this library is proposed by Heikki Hyyrö,
"Explaining and extending the bit-parallel approximate string matching
algorithm of Myers", (2001).}

%description %{_description}


%package -n python3-editdistance
Summary:        %{summary}

%description -n python3-editdistance %{_description}


%prep
%autosetup -n editdistance-%{version}

# Remove files generated by Cython to regenerate them; note that
# editdistance/_editdistance.cpp is not generated code.
grep -rl '/\* Generated by Cython' | xargs -r rm -v


%generate_buildrequires
%pyproject_buildrequires


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files -L editdistance

# 0.8.1: pep517 based build packages some files which should not be packaged
# and compile time warnings
# https://github.com/roy-ht/editdistance/issues/112
# “I couldn’t find any documentation on how to control this with the PDM build
# backend, so I worked around it downstream rather than offering a PR to fix it
# properly.”
find %{buildroot}%{python3_sitearch} -type f \( \
    -name '.git*' -o -name '*.cpp' -o -name '*.h' \
    \) -print -delete
sed -r -i '/\.(cpp|h)/d' %{pyproject_files}


%check
%pytest


%files -n python3-editdistance -f %{pyproject_files}
%license LICENSE
%doc README.md


%changelog
%autochangelog
